unit BookUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Buttons, Menus, ExtCtrls;

type
  TBookEditor = class( TForm )
    BookGrid: TStringGrid;
    MoveEd: TEdit;
    BadMoveButt: TSpeedButton;     DubiousMoveButt: TSpeedButton;
    normalMoveButt: TSpeedButton;  FineMoveButt: TSpeedButton;
    GreatMoveButt: TSpeedButton;   DeleteMoveButt: TSpeedButton;
    MainMenu1: TMainMenu;
    Options1: TMenuItem;
    FeedFromBoard1: TMenuItem;     Savenow1: TMenuItem;
    Button1: TButton;
    Image1: TImage;
    Edit1: TMenuItem;
    Mainbook1: TMenuItem;
    Guidebook1: TMenuItem;
    est1: TMenuItem;
    Label1: TLabel;
    Findshortlines1: TMenuItem;
    est2: TMenuItem;
    Longbooktest1: TMenuItem;
    Checkalternatives1: TMenuItem;
    Find1: TMenuItem;
    Missingreply1: TMenuItem;
    Button2: TButton;
    Button3: TButton;
    Longline1: TMenuItem;
    Randomleaf1: TMenuItem;
    CommentMemo: TMemo;
    Button4: TButton;
    Button5: TButton;
    procedure FormShow(Sender: TObject);
    procedure Savenow1Click( Sender: TObject );
    procedure FeedFromBoard1Click( Sender: TObject );
    procedure BadMoveButtClick( Sender: TObject );
    procedure DubiousMoveButtClick( Sender: TObject );
    procedure normalMoveButtClick( Sender: TObject );
    procedure FineMoveButtClick( Sender: TObject );
    procedure GreatMoveButtClick( Sender: TObject );
    procedure BookGridMouseDown( Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer );
    procedure DeleteMoveButtClick( Sender: TObject );
    procedure Button1Click( Sender: TObject );
    procedure FormCreate(Sender: TObject);
    procedure Mainbook1Click(Sender: TObject);
    procedure Guidebook1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BookGridDblClick(Sender: TObject);
    procedure est1Click(Sender: TObject);
    procedure Findshortlines1Click(Sender: TObject);
    procedure Longbooktest1Click(Sender: TObject);
    procedure Checkalternatives1Click(Sender: TObject);
    procedure Missingreply1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Longline1Click(Sender: TObject);
    procedure Randomleaf1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  public
    DispEntries   : Integer;
    BookSlotCount : string;
    procedure RefreshForm;
    procedure PolishLanguage;
    procedure EnglishLanguage;
    procedure LanguageSettings;
    function  GetLeafValue : Integer;
    procedure FindShortLine;
    procedure FindLongLine;
  end; // TBookEditor

var
  BookEditor: TBookEditor;

implementation

uses main;
{$R *.dfm}

procedure TBookEditor.PolishLanguage;
begin
     Caption := 'Edytor debiutw';
     Options1.Caption := 'Opcje';
     Button1.Caption := 'Czsto = 10';
     FeedFromBoard1.Caption := 'Czytaj z planszy';
     SaveNow1.Caption := 'Zapisz teraz';
     Edit1.Caption := 'Edytuj';
     MainBook1.Caption := 'gwn ksik';
     GuideBook1.Caption := 'ksik repertuarow';
     est1.Caption := 'Testuj losowy wariant';
     FindShortLines1.Caption := 'Krtki wariant';

     Find1.Caption := 'Znajd';
     LongLine1.Caption := 'Dugi wariant';
     LongBookTest1.Caption := 'Dugi test ksiki';
     MissingReply1.Caption := 'Luk w wariancie';
     CheckAlternatives1.Caption := 'Ruchy z odpowiedzi';
     RandomLeaf1.Caption := 'Losowy li';

     BookSlotCount := ' ruchw z 100.000';
     Label1.Caption := IntToStr( DispEntries ) + ' ruchw z 100.000';
end; // PolishLanguage

Procedure TBookEditor.EnglishLanguage;
begin
     Caption := 'Book editor';
     Options1.Caption := 'Options';
     Button1.Caption := 'Frequency = 10';
     FeedFromBoard1.Caption := 'Feed from board';
     SaveNow1.Caption := 'Save now';
     Edit1.Caption := 'Edit';
     MainBook1.Caption := 'Main book';
     GuideBook1.Caption := 'Guide book';
     est1.Caption := 'Test the book!';
     FindShortLines1.Caption := 'Short line';
     LongLine1.Caption := 'Long line';

     Find1.Caption := 'Find';
     LongBookTest1.Caption := 'Long book test';
     MissingReply1.Caption := 'Missing reply';
     CheckAlternatives1.Caption := 'Moves with continuation';
     RandomLeaf1.Caption := 'Random leaf';

     BookSlotCount := ' moves out of 100.000';
     Label1.Caption := IntToStr( DispEntries ) + ' moves out of 100.000';
end; // EnglishLanguage

procedure TBookEditor.LanguageSettings;
begin
  case Language of
       POLISH  : PolishLanguage;
       ENGLISH : EnglishLanguage;
  end; // of case
end; // LanguageSettings

function TBookEditor.GetLeafValue : Integer;
begin
  MyBook.GetRandomLeaf;
  Form1.Execute( 'sd 8' );
  Result := MySearch.Iterate( 8 );
  Form1.FenToGraphBoard( Form1.BoardToFen );
  RefreshForm;
  Form1.Execute('stop');
end; // GetLeafValue

procedure TBookEditor.FindShortLine;
          var A : Integer;
begin
     for A := 1 to 1000 do
     begin
        MyBook.GetRandomLeaf;
        MoveEd.Text := IntToStr( A );
        Application.ProcessMessages;
        if MyBook.BookMoveCount < 20
           then begin
             Form1.FenToGraphBoard( Form1.BoardToFen );
             RefreshForm;
             Form1.Execute( 'stop' );
             Break;
           end;
     end;
end; // FindShortLine

procedure TBookEditor.FindLongLine;
          var A : Integer;
begin
     for A := 1 to 1000 do
     begin
        MyBook.GetRandomLeaf;
        MoveEd.Text := IntToStr( A );
        Application.ProcessMessages;
        if MyBook.BookMoveCount > 30
           then begin
             Form1.FenToGraphBoard( Form1.BoardToFen );
             RefreshForm;
             Form1.Execute( 'stop' );
             Break;
           end;
     end;
end; // FindLongLine

procedure ResetMoveValue( Fen, Move : string );
          var A : Integer;
begin
  for A := 0 to NofEntries do
  if  ( BookArray[ BookNo, A ].Fen = Fen )
  and ( BookArray[ BookNo, A ].Move = Move )
  then begin
    BookArray[ BookNo, A ].Freq := 10;
    Exit;
  end;
end; // ResetMoveValue

procedure TBookEditor.RefreshForm;
          var A, B, Slot : Integer;
          FenString : string;
begin
  CommentMemo.Text := MyBook.CommentString;
  BookGrid.Color := WindowBgCol;
  CommentMemo.Color := WindowBgCol;
  Label1.Caption := IntToStr( DispEntries ) + BookSlotCount;
  MoveEd.Text := '';

  for A := 0 to 2 do
  for B := 0 to 12 do
    BookGrid.Cells[ A, B ] := '';

  FenString := Form1.BoardToFen;
  Slot := 0;
  for A := 1 to NofEntries do
  begin
     if BookArray[ BookNo, A ].Fen = FenString
        then begin
          BookGrid.Cells[ 0, Slot ] := BookArray[ BookNo, A ].Move;
          if BookArray[ BookNo, A ].Freq = -100
             then BookGrid.Cells[ 1, Slot ] := 'deleted'
             else BookGrid.Cells[ 1, Slot ] := IntToStr( BookArray[ BookNo, A ].Freq );

          case BookArray[ BookNo, A ].Learn of
            B_EXCL :  BookGrid.Cells[ 2, Slot ] := '!';
            B_FUN  :  BookGrid.Cells[ 2, Slot ] := '!?';
            B_DISL :  BookGrid.Cells[ 2, Slot ] := '?!';
            B_BAD  :  BookGrid.Cells[ 2, Slot ] := '?';
            B_END  :  BookGrid.Cells[ 2, Slot ] := 'END';
          end;  // of case

           Inc(Slot);
        end;
  end;
  MoveEd.Text := BookGrid.Cells[ 0, 0 ];

end; // RefreshForm

procedure TBookEditor.FormShow( Sender: TObject );
begin
  RefreshForm;
end; // FormShow

procedure TBookEditor.SaveNow1Click( Sender: TObject );
begin
   Form1.InfoMessage( sBookSaving );
   MyBook.SaveBook;
   Form1.InfoMessage( sBookSaved );
end; // SaveNow1Click

procedure TBookEditor.FeedFromBoard1Click( Sender: TObject );
begin
     if FeedFromBoard1.Checked
        then FeedFromBoard1.Checked := False
        else begin
          FeedFromBoard1.Checked := True;
          Form1.Execute('stop');
        end;
end; // FeedFromBoard1Click

procedure TBookEditor.BadMoveButtClick( Sender: TObject );
begin
  MyBook.MarkBookMove( Form1.BoardToFen, MoveEd.Text, B_BAD );
  RefreshForm;
end; // BadMoveButtClick

procedure TBookEditor.DubiousMoveButtClick( Sender: TObject );
begin
  MyBook.MarkBookMove( Form1.BoardToFen, MoveEd.Text, B_DISL );
  RefreshForm;
end; // DubiousMoveButtClick

procedure TBookEditor.NormalMoveButtClick( Sender: TObject );
begin
  MyBook.MarkBookMove( Form1.BoardToFen, MoveEd.Text, B_NORM );
  RefreshForm;
end; // NormalMoveButtClick

procedure TBookEditor.FineMoveButtClick( Sender: TObject );
begin
  MyBook.MarkBookMove( Form1.BoardToFen, MoveEd.Text, B_FUN );
  RefreshForm;
end; // FineMoveButtClick

procedure TBookEditor.GreatMoveButtClick( Sender: TObject );
begin
  MyBook.MarkBookMove( Form1.BoardToFen, MoveEd.Text, B_EXCL );
  RefreshForm;
end; // GreatMoveButtClick

procedure TBookEditor.BookGridMouseDown( Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer );
  var Col, Row : Integer;
begin
   BookGrid.MouseToCell( X, Y, Col, Row );
   MoveEd.Text := BookGrid.Cells[ 0, Row ];
end; // BookGridMouseDown

procedure TBookEditor.DeleteMoveButtClick( Sender: TObject );
begin
   MyBook.DeleteBookMove( Form1.BoardToFen, MoveEd.Text );
   Dec( DispEntries );
   Label1.Caption := IntToStr( DispEntries ) + BookSlotCount;
   RefreshForm;
end; // DeleteMoveButtClick

// Temporary button, to be used until the move frequencies
// are mended.

procedure TBookEditor.Button1Click( Sender: TObject );
begin
   ResetMoveValue( Form1.BoardToFen, MoveEd.Text );
   RefreshForm;
end; // Button1Click

procedure TBookEditor.FormCreate( Sender: TObject );
begin
   DispEntries := NofEntries;
   LanguageSettings;
   Top := 1;
   Left := form1.Left + Form1.Width + 1;
   if FileExists( PictureString )
      then Image1.Picture.LoadFromFile( PictureString );

   case Language of
      POLISH  : BookSlotCount := ' ruchw z 100.000';
      ENGLISH : BookSlotCount := ' moves out of 100.000';
   end; // of case
end; // FormCreate

procedure TBookEditor.Mainbook1Click( Sender: TObject );
begin
   BookNo := 1;
   BookName := MainBookName;
   MainBook1.Checked := True;
   RefreshForm;
end; // MainBook1Click

procedure TBookEditor.Guidebook1Click(Sender: TObject);
begin
  BookNo := 0;
  BookName := GuideBookName;
  GuideBook1.Checked := True;
  RefreshForm;
end; // GuideBook1Click

procedure TBookEditor.FormResize( Sender: TObject );
begin
  Image1.Width := Width - 10;
  Image1.Height := Height - 60;
end; // FormResize

procedure TBookEditor.BookGridDblClick( Sender : TObject );
begin
  Form1.Execute( 'stop' );
  Form1.Execute( MoveEd.Text );
  Form1.FenToGraphBoard( Form1.BoardToFen );
  RefreshForm;
end; // BookGridDblClick;

procedure TBookEditor.est1Click( Sender: TObject );
begin
  GetLeafValue;
end;

procedure TBookEditor.FindShortLines1Click( Sender: TObject );
begin
  FindShortLine;
end; // FindShortLines1Click

procedure TBookEditor.Longbooktest1Click( Sender: TObject );
          var A, Temp : Integer;
begin
   case Language of
   ENGLISH:
   ShowMessage('Program will search random leaf positions' + LINE_END +
               'at  depth  8  to see  if  the  result  is' + LINE_END +
               'unbalanced.  If  so, test  is terminated.' + LINE_END +
               'If not, it will run for 100 iterations.' );
   POLISH:
   ShowMessage('Program zacznie przeszukiwa losowo wybrane'  + LINE_END +
               'pozycje  kocowe wariantw na  gboko 8 '  + LINE_END +
               'aby sprawdzi, czy nie s one zbyt niezrwno-' + LINE_END +
               'waone. Wykrycie takiego przypadku koczy' + LINE_END +
               'test. W przeciwnym wypadku trwa on 100 iteracji' );
   end; // of case

   for A := 1 to 100 do
   begin
     Temp := GetLeafValue;
     if ( ( Temp > 50  ) and ( Temp < 1000  ) )
     or ( ( Temp < -50 ) and ( Temp > -1000 ) )
        then begin
          Beep;          // Temp < 1000 ensures that
          Break;         // the search is completed.
        end;
   end;
   Form1.Execute( 'stop' );
   ShowMessage('Test completed');
end; // LongBookTest1Click

procedure TBookEditor.CheckAlternatives1Click(Sender: TObject);
          var Temp : string;
begin
     Temp := MyBook.GetMissingMove;
     if Temp <> ''
        then ShowMessage(Temp);
end; // CheckAlternatives1Click

procedure TBookEditor.MissingReply1Click( Sender: TObject );
          var A : Integer;
          Temp : string;
begin
  for A := 1 to 100 do
  begin
    MyBook.GetRandomLeaf;
    MoveEd.Text := IntToStr( A );
    Application.ProcessMessages;
    Temp := MyBook.GetMissingMove;
    if Temp <> ''
       then begin
         ShowMessage( Temp );
         Exit;
       end;
  end;
end; // MissingReply1Click

procedure TBookEditor.Button2Click(Sender: TObject);
begin
   MyBook.WriteBookMove( Form1.BoardToFen, 'FILL' );
   RefreshForm;
end;

procedure TBookEditor.Button3Click(Sender: TObject);
begin
  MyBook.MarkBookMove( Form1.BoardToFen, MoveEd.Text, B_END );
  RefreshForm;
end;

procedure TBookEditor.Longline1Click(Sender: TObject);
begin
   FindLongLine;
end;

procedure TBookEditor.Randomleaf1Click(Sender: TObject);
begin
    MyBook.GetRandomLeaf;
end;

procedure TBookEditor.Button4Click(Sender: TObject);
begin
MyBook.WriteComment(Form1.BoardToFen, CommentMemo.Text);
end;

procedure TBookEditor.Button5Click(Sender: TObject);
begin
MyBook.SaveComments;
end;

end.
