function IsNumber( Ch : Char ) : Boolean;
begin
  if (Ch='0') or (Ch='1') or (Ch='2') or (Ch='3')
  or (Ch='4') or (Ch='5') or (Ch='6') or (Ch='7')
  or (Ch='8') or (Ch='9') or (Ch ='-')
     then Result := True
     else Result := False;
end; // IsNumber

function ExtractNumStr( StrFrom : string ) : string;
         var A : Integer;
         NumberStarted : Boolean;
begin
  Result := '';
  NumberStarted := False;
  for A := 1 to Length( StrFrom ) do
  begin  // loop
    if  IsNumber( StrFrom[A] )
       then begin
         if ( A = 1 )
         or ( StrFrom[ A-1 ] = ' ' )
         or ( StrFrom[ A-1 ] = '=' )
            then NumberStarted := True;
         if NumberStarted
            then Result := Result + StrFrom[ A ];
       end
       else begin
         if NumberStarted
            then Exit;
       end;
  end; // loop
end; // ExtractNumStr

function ExtractNumVal( StrFrom : string ) : Integer;
         var TempString : string;
begin
     TempString := ExtractNumStr( StrFrom );
     Result := StrToInt( TempString );
end; // ExtractNumVal

function ExtractBracketStr( StrFrom : string ) : string;
         var A : Integer;
         StrStarted : Boolean;
begin
   Result := '';
   StrStarted := False;
   for A := 1 to Length( StrFrom ) do
   begin
        if StrStarted
        then begin
           if StrFrom[ A ] = '>'
              then Exit
              else Result := Result + StrFrom[ A ];
        end;
        if StrFrom[ A ] = '<'
           then StrStarted := True;
   end;
end; // ExtractBracketStr

procedure TForm1.ProcessInitString( CurrentString : string );

function FoundString( LookingFor : string ) : Boolean;
begin
    if AnsiContainsStr( CurrentString, LookingFor )
       then Result := True
       else Result := False;
end; // FoundString

begin
  if ( CurrentString[ 1 ] = ';' )
  or ( Length( CurrentString ) < 2 )
  or ( AnsiContainsStr( CurrentString, 'FILE_END' ) )
     then Exit;  // don't process the comment line

  // set graphical parameters
  {$IFNDEF XBOARD}
  if FoundString( 'CHESS_FONT' )
     then begin
       // some kind of "if exists" routine
       BoardGrid.Font.Name := ExtractBracketStr( CurrentString);
     end;
  if FoundString( 'BACKGROUND_IMAGE' )
     then PictureString := ExtractBracketStr( CurrentString );
  if FoundString( 'CHESS_FONT_SIZE' )
     then Form1.BoardGrid.Font.Size := StrToInt( ExtractNumStr( CurrentString ) );
  if FoundString( 'SQUARE_SIZE' )
     then begin
        BoardGrid.DefaultRowHeight := ExtractNumVal( CurrentString );
        BoardGrid.DefaultColWidth :=  ExtractNumVal( CurrentString );
     end;
  if FoundString( 'BOARD_SIZE' )
     then begin
        BoardGrid.Height :=  ExtractNumVal( CurrentString );
        BoardGrid.Width :=   ExtractNumVal( CurrentString );
     end;
  if FoundString( 'BOARD_LINE_WIDTH' )
     then Form1.BoardGrid.GridLineWidth := ExtractNumVal( CurrentString );
  if FoundString( 'LIGHT_SQUARES' )
     then LtSqrCol := ExtractNumVal( CurrentString );
  if FoundString( 'DARK_SQUARES' )
     then DarkSqrCol := ExtractNumVal( CurrentString );
  if FoundString( 'WHITE_PIECES' )
     then WhitePieceCol := ExtractNumVal( CurrentString );
  if FoundString( 'BLACK_PIECES' )
     then BlackPieceCol := ExtractNumVal( CurrentString );
  if FoundString( 'DARK_FONT_COLOR' )
     then DarkFontCol := ExtractNumVal( CurrentString );
  if FoundString( 'LIGHT_FONT_COLOR' )
     then LightFontCol := ExtractNumVal( CurrentString );
  if FoundString( 'WINDOW_FONT_COLOR' )
     then WindowFontCol := ExtractNumVal( CurrentString );
  if FoundString( 'WINDOW_COLOR' )
     then WindowBgCol := ExtractNumVal( CurrentString );
  if FoundString( 'BOARD_BG_COLOR' )
     then BoardBgColor := ExtractNumVal( CurrentString );
  if FoundString( 'NOTATION' )
     then begin
       if FoundString( 'SAN' )
          then Notation := N_SAN;
       if FoundString( 'PGN' )
          then Notation := N_PGN;
     end;
  if FoundString( 'LANGUAGE' )
     then begin
       if FoundString( 'POLISH' )
          then Language := POLISH;
       if FoundString( 'ENGLISH' )
          then Language := ENGLISH;
     end;
  {$ENDIF}

  // set resigning conditions
  if FoundString( 'RESIGN_VALUE' )
     then RESIGN_VALUE := ExtractNumVal( CurrentString );
  if FoundString( 'RESIGN_BOARD_VAL' )
     then RESIGN_BOARD_VAL := ExtractNumVal( CurrentString );
  if FoundString( 'RESIGN_DURATION' )
     then RESIGN_DURATION := ExtractNumVal( CurrentString );

  // set engine preferences
  if FoundString( 'MAIN_BOOK_NAME' )
     then MainBookName := ExtractBracketStr( CurrentString );
  if FoundString( 'GUIDE_BOOK_NAME' )
     then begin
       GuideBookName := ExtractBracketStr( CurrentString );
       {$IFNDEF XBOARD}
       if ExtractBracketStr( CurrentString ) = 'books/MainBook.hop' then Normal1.Checked := True;
       if ExtractBracketStr( CurrentString ) = 'books/Broad.hop' then Broad1.Checked := True;
       if ExtractBracketStr( CurrentString ) = 'books/Hypermodern.hop' then Hypermodern1.Checked := True;
       if ExtractBracketStr( CurrentString ) = 'books/Gambit.hop'  then Gambit1.Checked := True;
       if ExtractBracketStr( CurrentString ) = 'books/Fighter.hop' then Fighter1.Checked := True;
       if ExtractBracketStr( CurrentString ) = 'books/Unusual.hop' then Unusual1.Checked := True;
       if ExtractBracketStr( CurrentString ) = 'books/Solid.hop'   then Solid1.Checked := True;
       {$ENDIF}
     end;

  if FoundString( 'STYLE_NAME' )
     then begin
       if FoundString('smart') then Smart1.Checked := True;
       if FoundString('objective') then Objective1.Checked := True;
     end;

  if FoundString( 'EVAL_GRAIN' )
     then MyEval.GRAIN := ExtractNumVal( CurrentString );

  if FoundString( 'IMBALANCE_CORRECTION' )
     then MyEval.IMBALANCE := ExtractNumVal( CurrentString );

  if FoundString( 'TEMPO' )
     then MyEval.TEMPO := ExtractNumVal( CurrentString );

  // piece values
  if FoundString( 'P_VALUE_N' )
     then MyEval.P_VALUE_N := ExtractNumVal( CurrentString );

  if FoundString( 'P_VALUE_DE' )
     then MyEval.P_VALUE_DE := ExtractNumVal( CurrentString );

  if FoundString( 'P_VALUE_AH' )
     then MyEval.P_VALUE_AH := ExtractNumVal( CurrentString );

  if FoundString( 'B_VALUE' )
     then MyEval.B_VALUE := ExtractNumVal( CurrentString );

  if  ( FoundString( 'N_VALUE' ) )
  and ( not FoundString( 'RESIGN_VALUE' ) ) // bugfix
     then MyEval.N_VALUE := ExtractNumVal( CurrentString );

  if FoundString( 'R_VALUE' )
     then MyEval.R_VALUE := ExtractNumVal( CurrentString );

  if FoundString( 'Q_VALUE' )
     then MyEval.Q_VALUE := ExtractNumVal( CurrentString );

  // booleans
  if FoundString( 'SCALE MATERIAL ON' )
     then MyEval.DoScaleMat := TRUE;

  if FoundString( 'SCALE MATERIAL OFF' )
     then MyEval.DoScaleMat := FALSE;

  if FoundString( 'OUTPOSTS ON')
     then MyEval.DoOutposts := TRUE;

  if FoundString( 'OUTPOSTS OFF')
     then MyEval.DoOutposts := FALSE;

  if FoundString( 'ADVANCED PAWN STRUCT ON' )
     then MyEval.DoPawnStructs := TRUE;

  if FoundString( 'ADVANCED PAWN STRUCT OFF' )
     then MyEval.DoPawnStructs := FALSE;

  if FoundString( 'COMBINATIONS ON' )
     then MyEval.DoPatterns := TRUE;

  if FoundString( 'COMBINATIONS OFF')
     then MyEval.DoPatterns := FALSE;

  // percents
  if FoundString( 'AGGRESSION' )
     then ProgAttack := ExtractNumVal( CurrentString );

  if FoundString( 'CAUTION' )
     then OppoAttack := ExtractNumVal( CurrentString );

  if FoundString( 'FREEDOM' )
     then ProgMobility := ExtractNumVal( CurrentString );

  if FoundString( 'RESTRAINT' )
     then OppoMobility := ExtractNumVal( CurrentString );

  if FoundString( 'MY_PAWN_SHIELD' )
     then ProgShield := ExtractNumVal( CurrentString );

  if FoundString( 'OPPO_PAWN_SHIELD' )
     then OppoShield := ExtractNumVal( CurrentString );

  if FoundString( 'P_DOUBLE' )
     then MyEval.P_DOUBLE := ExtractNumVal( CurrentString );

  if FoundString( 'P_WEAK' )
     then MyEval.P_WEAK := ExtractNumVal( CurrentString );

  if FoundString( 'P_BLOCKED_DE' )
     then MyEval.P_BLOCKED_DE := ExtractNumVal( CurrentString );

  if FoundString( 'P_PROTECTS_K' )
     then MyEval.P_PROTECTS_K := ExtractNumVal( CurrentString );

  if FoundString( 'P_DESERTED_K' )
     then MyEval.P_DESERTED_K := ExtractNumVal( CurrentString );

  if FoundString( 'P_RUNNING' )
     then MyEval.P_RUNNING := ExtractNumVal( CurrentString );

  if FoundString( 'KNIGHT_MOB_UNIT' )
     then MyEval.N_MOB_UNIT := ExtractNumVal( CurrentString );

  if FoundString( 'KNIGHT_TRAPPED' )
     then MyEval.N_TRAPPED := ExtractNumVal( CurrentString );

  if FoundString( 'KNIGHT HINDERS' )
     then MyEval.N_BLOCK_P := ExtractNumVal( CurrentString );

  if FoundString( 'B_PAIR' )
     then MyEval.B_PAIR := ExtractNumVal( CurrentString );

  if FoundString( 'B_PINS' )
     then MyEval.B_PIN := ExtractNumVal( CurrentString );

  if FoundString( 'B_TRAP_A7' )
     then MyEval.B_TRAP_A7 := ExtractNumVal( CurrentString );

  if FoundString( 'B_TRAP_A6' )
     then MyEval.B_TRAP_A6 := ExtractNumVal( CurrentString );

  if FoundString( 'B_NO_FIANCH' )
     then MyEval.B_NO_FIANCH := ExtractNumVal( CurrentString );

  if FoundString( 'B_CENT_MISS' )
     then MyEval.B_CENT_MISS := ExtractNumVal( CurrentString );

  if FoundString( 'B_UNSAFE' )
     then MyEval.B_UNSAFE := ExtractNumVal( CurrentString );

  if FoundString( 'R_OPEN' )
     then MyEval.R_OPEN := ExtractNumVal( CurrentString );

  if FoundString( 'R_HALF' )
     then MyEval.R_HALF := ExtractNumVal( CurrentString );

  if FoundString( 'R_PRESS_K' )
     then MyEval.R_PRESS_K := ExtractNumVal( CurrentString );

  if FoundString( 'R_PAIR' )
     then MyEval.R_PAIR := ExtractNumVal( CurrentString );

  if FoundString( 'Q_DIST_K' )
     then MyEval.Q_DIST_K := ExtractNumVal( CurrentString );

  if FoundString( 'Q_EARLY' )
     then MyEval.Q_EARLY := ExtractNumVal( CurrentString );

  if FoundString( 'K_BLOCK_R' )
     then MyEval.K_BLOCK_R := ExtractNumVal( CurrentString );

  if FoundString( 'K_UNCASTLED' )
     then MyEval.K_UNCASTLED := ExtractNumVal( CurrentString );

  if FoundString( 'K_COLOR_WEAK' )
     then MyEval.K_COLOR_WEAK := ExtractNumVal( CurrentString );

  if FoundString( 'N_ATTACKS_K' )
     then MyEval.N_ATTACKS_K := ExtractNumVal( CurrentString );

  if FoundString( 'B_ATTACKS_K' )
     then MyEval.B_ATTACKS_K := ExtractNumVal( CurrentString );

  if FoundString( 'R_ATTACKS_K' )
     then MyEval.R_ATTACKS_K := ExtractNumVal( CurrentString );

  if FoundString( 'Q_ATTACKS_K' )
     then MyEval.Q_ATTACKS_K := ExtractNumVal( CurrentString );

  // search options
  if FoundString( 'NULL_IN_PV ON' )
     then MySearch.NULL_IN_PV := True;
  if FoundString( 'NULL_IN_PV OFF' )
     then MySearch.NULL_IN_PV := False;

  if FoundString( 'IID ON' )
     then MySearch.DO_IID := True;
  if FoundString( 'IID OFF' )
     then MySearch.DO_IID := False;

  if FoundString( 'PVS ON' )
     then MySearch.DO_PVS := True;
  if FoundString( 'PVS OFF' )
     then MySearch.DO_PVS := False;

  if FoundString( 'LMR ON' )
     then MySearch.DO_LMR := True;
  if FoundString( 'LMR OFF' )
     then MySearch.DO_LMR := False;

  if FoundString( 'FUT_1' )
     then begin
       if FoundString( 'OFF' )
          then MySearch.DO_FUT1 := False
          else begin
            MySearch.DO_FUT1 := True;
            MySearch.FUT_1 := ExtractNumVal( CurrentString );
          end;
     end; // FUT_1

  if FoundString( 'FUT_2' )
     then begin
       if FoundString( 'OFF' )
          then MySearch.DO_FUT2 := False
          else begin
            MySearch.DO_FUT2 := True;
            MySearch.FUT_2 := ExtractNumVal( CurrentString );
          end;
     end; // FUT_2

  if FoundString( 'RAZOR' )
     then begin
       if FoundString( 'OFF' )
          then MySearch.DO_RAZOR := False
          else begin
            MySearch.DO_RAZOR := True;
            MySearch.RAZOR_LIMIT := ExtractNumVal( CurrentString );
          end;
     end; // RAZOR

  if FoundString( 'DISABLE_PVS_FROM' )
     then MySearch.DISABLE_PVS_FROM := ExtractNumVal( CurrentString );
  if FoundString( 'DISABLE_IID_FROM' )
     then MySearch.DISABLE_IID_FROM := ExtractNumVal( CurrentString );
  if FoundString( 'ASPIRATION_WINDOW' )
     then MySearch.ASP := ExtractNumVal( CurrentString );
end; // ProcessCurrentString

procedure TForm1.ReadIniFile( FileName : string );
          var CurrentString : string;
begin
   AssignFile( IniFile, FileName );
   if FileExists( FileName )
      then begin
        Reset( IniFile );
        while not Eof( IniFile ) do
        begin
          Readln( IniFile, CurrentString );
          CurrentString := TrimLeft( CurrentString );
          ProcessInitString( CurrentString );
        end;
        CloseFile( IniFile );
      end;
      {$IFNDEF XBOARD} RefreshBoardDisplay; {$ENDIF}
end; // ReadIniFile

procedure TForm1.WriteIniFile( FileName : string );
begin
   AssignFile( IniFile, FileName );
   Rewrite( IniFile );
   Writeln( IniFile, '; Clericus / Hopeless Chess initialization file');
   Writeln( IniFile, ';');

   {$IFNDEF XBOARD}
   Writeln( IniFile, ' BACKGROUND_IMAGE <' + PictureString + '>' );
   Writeln( IniFile, ' CHESS_FONT <' + Form1.BoardGrid.Font.Name + '>' );
   Writeln( IniFile, ' CHESS_FONT_SIZE ' + IntToStr(Form1.BoardGrid.Font.Size) );
   Writeln( IniFile, ' BOARD_SIZE ' + IntToStr(Form1.BoardGrid.Height) );
   Writeln( IniFile, ' BOARD_LINE_WIDTH ' + IntToStr(Form1.BoardGrid.GridLineWidth) );
   Writeln( IniFile, ' SQUARE_SIZE '   + IntToStr(Form1.BoardGrid.DefaultColWidth) );
   Writeln( IniFile, ' LIGHT_SQUARES ' + IntToStr(LtSqrCol) );
   Writeln( IniFile, ' DARK_SQUARES '  + IntToStr(DarkSqrCol) );
   Writeln( IniFile, ' WHITE_PIECES '  + IntToStr(WhitePieceCol) );
   Writeln( IniFile, ' BLACK_PIECES '  + IntToStr(BlackPieceCol) );
   Writeln( IniFile, ' WINDOW_COLOR ' + IntToStr( WindowBgCol ) );
   Writeln( IniFile, ' WINDOW_FONT_COLOR ' + IntToStr( WindowFontCol ) );
   Writeln( IniFile, ' LIGHT_FONT_COLOR ' + IntToStr( LightFontCol ) );
   Writeln( IniFile, ' DARK_FONT_COLOR ' + IntToStr( DarkFontCol ) );
   Writeln( IniFile, ' BOARD_BG_COLOR ' + IntToStr(BoardBgColor) );

   if Notation = N_PGN
      then Writeln( IniFile, ' NOTATION PGN' );
   if Notation = N_SAN
      then Writeln( IniFile, ' NOTATION SAN' );
   if Language = POLISH
      then Writeln( IniFile, ' LANGUAGE POLISH' );
   if Language = ENGLISH
      then Writeln( IniFile, ' LANGUAGE ENGLISH' );
   {$ENDIF}

   Writeln( IniFile, ';');
   Writeln( IniFile, '; EVALUATION SETTINGS' );
   Writeln( IniFile, ';');

   Writeln( IniFile, ' MAIN_BOOK_NAME <' + MainBookName + '>' );
   Writeln( IniFile, ' GUIDE_BOOK_NAME <' + GuideBookName + '>' );
   Writeln( IniFile, ';' );
   Writeln( IniFile, ' Q_VALUE ' + IntToStr( MyEval.Q_VALUE ) );
   Writeln( IniFile, ' R_VALUE ' + IntToStr( MyEval.R_VALUE ) );
   Writeln( IniFile, ' B_VALUE ' + IntToStr( MyEval.B_VALUE ) );
   Writeln( IniFile, ' N_VALUE ' + IntToStr( MyEval.N_VALUE ) );
   Writeln( IniFile, ' P_VALUE_N ' + IntToStr( MyEval.P_VALUE_N ) );
   Writeln( IniFile, ' P_VALUE_DE ' + IntToStr( MyEval.P_VALUE_DE ) );
   Writeln( IniFile, ' P_VALUE_AH ' + IntToStr( MyEval.P_VALUE_AH ) );
   Writeln( IniFile, ';' );

   Writeln( IniFile, ' EVAL_GRAIN ' + IntToStr( MyEval.GRAIN ) );
   Writeln( IniFile, ' IMBALANCE_CORRECTION ' + IntToStr( MyEval.IMBALANCE ) );
   Writeln( IniFile, ' TEMPO ' + IntToStr( MyEval.TEMPO ) );
   Writeln( IniFile, ';' );
   Writeln( IniFile, ' AGGRESSION ' + IntToStr( ProgAttack ) );
   Writeln( IniFile, ' CAUTION '    + IntToStr( OppoAttack ) );
   Writeln( IniFile, ' FREEDOM '    + IntToStr( ProgMobility ) );
   Writeln( IniFile, ' RESTRAINT '  + IntToStr( OppoMobility ) );
   Writeln( IniFile, ' MY_PAWN_SHIELD ' + IntToStr( ProgShield ) );
   Writeln( IniFile, ' OPPO_PAWN_SHIELD ' + IntToStr( OppoShield ) );
   Writeln( IniFile, ';' );

   Writeln( IniFile, ' P_DOUBLE ' + IntToStr( MyEval.P_DOUBLE ) );
   Writeln( IniFile, ' P_WEAK '   + IntToStr( MyEval.P_WEAK ) );
   Writeln( IniFile, ' P_BLOCKED_DE ' + IntToStr( MyEval.P_BLOCKED_DE ) );
   Writeln( IniFile, ' P_PROTECTS_K ' + IntToStr( MyEval.P_PROTECTS_K ) );
   Writeln( IniFile, ' P_DESERTED_K ' + IntToStr( MyEval.P_DESERTED_K ) );
   Writeln( IniFile, ' P_RUNNING ' + IntToStr( MyEval.P_RUNNING ) );
   Writeln( IniFile, ';' );

   Writeln( IniFile, ' KNIGHT_MOB_UNIT ' + IntToStr( MyEval.N_MOB_UNIT ) );
   Writeln( IniFile, ' KNIGHT_TRAPPED ' + IntToStr( MyEval.N_TRAPPED ) );
   Writeln( IniFile, ' KNIGHT_HINDERS_C ' + IntToStr( MyEval.N_BLOCK_P ) );
   Writeln( IniFile, ';' );

   Writeln( IniFile, ' B_PAIR ' + IntToStr( MyEval.B_PAIR ) );
   Writeln( IniFile, ' B_PINS ' + IntToStr( MyEval.B_PIN ) );
   Writeln( IniFile, ' B_TRAP_A7 '   + IntToStr( MyEval.B_TRAP_A7 ) );
   Writeln( IniFile, ' B_TRAP_A6 '   + IntToStr( MyEval.B_TRAP_A6 ) );
   Writeln( IniFile, ' B_NO_FIANCH ' + IntToStr( MyEval.B_NO_FIANCH ) );
   Writeln( IniFile, ' B_CENT_MISS ' + IntToStr( MyEval.B_CENT_MISS ) );
   Writeln( IniFile, ' B_UNSAFE ' + IntToStr( MyEval.B_UNSAFE ) );
   Writeln( IniFile, ';' );

   Writeln( IniFile, ' R_PAIR ' + IntToStr( MyEval.R_PAIR ) );
   Writeln( IniFile, ' R_OPEN ' + IntToStr( MyEval.R_OPEN ) );
   Writeln( IniFile, ' R_HALF ' + IntToStr( MyEval.R_HALF ) );
   Writeln( IniFile, ' R_PRESS_K ' + IntToStr( MyEval.R_PRESS_K ) );
   Writeln( IniFile, ';' );

   Writeln( IniFile, ' Q_DIST_K ' + IntToStr( MyEval.Q_DIST_K ) );
   Writeln( IniFile, ' Q_EARLY ' + IntToStr( MyEval.Q_EARLY ) );
   Writeln( IniFile, ';' );

   Writeln( IniFile, ' K_BLOCK_R ' + IntToStr( MyEval.K_BLOCK_R ) );
   Writeln( IniFile, ' K_UNCASTLED ' + IntToStr( MyEval.K_UNCASTLED ) );
   Writeln( IniFile, ' K_COLOR_WEAK ' + IntToStr( MyEval.K_COLOR_WEAK ) );
   Writeln( IniFile, ';' );
   Writeln( IniFile, ' N_ATTACKS_K ' + IntToStr( MyEval.N_ATTACKS_K ) );
   Writeln( IniFile, ' B_ATTACKS_K ' + IntToStr( MyEval.B_ATTACKS_K ) );
   Writeln( IniFile, ' R_ATTACKS_K ' + IntToStr( MyEval.R_ATTACKS_K ) );
   Writeln( IniFile, ' Q_ATTACKS_K ' + IntToStr( MyEval.Q_ATTACKS_K ) );
   Writeln( IniFile, ';');

   Writeln( IniFile, ' RESIGN_VALUE ' + IntToStr(RESIGN_VALUE) );
   Writeln( IniFile, ' RESIGN_BOARD_VAL ' + IntToStr(RESIGN_BOARD_VAL) );
   Writeln( IniFile, ' RESIGN_DURATION ' + IntToStr(RESIGN_DURATION) );
   Writeln( IniFile, ';');

   if MyEval.DoScaleMat = True
      then Writeln( IniFile, ' SCALE MATERIAL ON' )
      else Writeln( IniFile, ' SCALE MATERIAL OFF ' );

   if MyEval.DoPawnStructs = True
      then Writeln( IniFile, ' ADVANCED PAWN STRUCT ON ' )
      else Writeln( IniFile, ' ADVANCED PAWN STRUCT OFF ' );

   if MyEval.DoOutposts = True
      then Writeln( IniFile, ' OUTPOSTS ON ' )
      else Writeln( IniFile, ' OUTPOSTS OFF ' );

   if MyEval.DoPatterns = True
      then Writeln( IniFile, ' COMBINATIONS ON ' )
      else Writeln( IniFile, ' COMBINATIONS OFF ');

   Writeln( IniFile, ';' );
   Writeln( IniFile, '; Search parameters: ');
   Writeln( IniFile, ';' );

   if MySearch.NULL_IN_PV = True
      then Writeln( IniFile, ' NULL_IN_PV ON' )
      else Writeln( IniFile, ' NULL_IN_PV OFF' );

   if MySearch.DO_IID
      then Writeln( IniFile, ' IID ON ' )
      else Writeln( IniFile, ' IID OFF ' );

   if MySearch.DO_PVS
      then Writeln( IniFile, ' PVS ON ' )
      else Writeln( IniFile, ' PVS OFF ' );

   if MySearch.DO_LMR
      then Writeln( IniFile, ' LMR ON ' )
      else Writeln( IniFile, ' LMR OFF ' );

   Writeln( IniFile, ' DISABLE_PVS_FROM ' + IntToStr( MySearch.DISABLE_PVS_FROM ) );
   Writeln( IniFile, ' DISABLE_IID_FROM ' + IntToStr( MySearch.DISABLE_IID_FROM ) );

   if MySearch.DO_FUT1
      then Writeln( IniFile, ' FUT_1 ' + IntToStr( MySearch.FUT_1 ) )
      else Writeln( IniFile, ' FUT_1 OFF' );

   if MySearch.DO_FUT2
      then Writeln( IniFile, ' FUT_2 ' + IntToStr( MySearch.FUT_2 ) )
      else Writeln( IniFile, ' FUT_2 OFF' );

   if MySearch.DO_RAZOR
      then Writeln( IniFile, ' RAZOR ' + IntToStr( MySearch.RAZOR_LIMIT ) )
      else Writeln( IniFile, ' RAZOR OFF');

   Writeln( IniFile, ' ASPIRATION_WINDOW ' + IntToStr( MySearch.ASP ) );

   CloseFile( IniFile );
end; // WriteIniFile

procedure TForm1.RestoreSettings;
begin
   MyEval.Destroy;
   MyEval := TEval.Create;
   {$IFNDEF XBOARD}
   Form1.BoardGrid.Font.Name := 'Chess Merida';
   Form1.BoardGrid.Font.Size := 28;
   Form1.BoardGrid.Height := 353;
   Form1.BoardGrid.Width := 353;
   Form1.BoardGrid.DefaultColWidth  := 40;
   Form1.BoardGrid.DefaultRowHeight := 40;
   Form1.BoardGrid.GridLineWidth    := 1;
   PictureString := 'graf/marble3.bmp';
   LtSqrCol      := clSilver;
   DarkSqrCol    := clMedGray;
   WhitePieceCol := clWhite;
   BlackPieceCol := clBlack;
   LightFontCol  := clGray;
   DarkFontCol   := clBlack;
   WindowFontCol := clBlack;
   WindowBgCol   := clWhite;
   {$ENDIF}
   BookName      := 'MainBook.hop';
   GuideBookName := 'MainBook.hop';
   RESIGN_VALUE  := -900;
   RESIGN_BOARD_VAL := -500;
   RESIGN_DURATION  := 3;
   ProgMobility  := 100;
   OppoMobility  := 150;
   ProgAttack    := 200;
   OppoAttack    := 200;
   ProgShield    := 100;
   OppoShield    := 100;
   WriteIniFile('clericus.ini');
end; // RestoreSettings